*corr rel vs absolute.do
capture log close
log using "U:\papers and projects\earnings associations\do\sensitivity_rr\corr rel vs absolute.log", replace
set more 1
clear
program drop _all
set mem 500M

set matsize 3000


#delimit cr



   use "U:\papers and projects\earnings associations\dta\earn_tab_20_ties.dta", clear


   *Year categories

    #delimit ;
    recode y  1968/1971 = 1968 1972/1975 = 1972 1976/1979 = 1976 1980/1983 = 1980
              1984/1987 = 1984 1988/1991 = 1988 1992/1995 = 1992 1996/1999 = 1996
              2000/2003 = 2000 2004/2006 = 2004 ;
    #delimit cr


    collapse (sum) freq WEIGHT (mean) Wscale Hscale, by(y Hp Wp)


    *There should be 21x21x11 == 4410 cells in the table.  There are.

     display _N

      summarize Wscale [w=freq]
      summarize Hscale [w=freq]


***************
* CORRELATION *
***************



      *I use aweights here.  The same answer is obtained using fweights.


         foreach num of numlist 1968 1972 1976 1980 1984 1988 1992 1996 2000 2004 {
          quietly corr Wp Hp if Wp ~= 0 & Hp ~= 0 & y == `num' [aw=WEIGHT]
          quietly gen rworkp`num' = r(rho)
           quietly corr Wp Hp if                             y == `num' [aw=WEIGHT]
           quietly gen rallp`num' = r(rho)
          quietly corr Wscale Hscale if Wscale ~= 0 & Hscale ~= 0 & y == `num' [aw=WEIGHT]
          quietly gen rworks`num' = r(rho)
           quietly corr Wscale Hscale if                             y == `num' [aw=WEIGHT]
           quietly gen ralls`num' = r(rho)
         }


         preserve

         keep in 1
         collapse rwork* rall*

         gen id = 1
         reshape long rworkp rallp rworks ralls, i(id) j(y)

         lab var rworkp "Dual-Earner Couples, Percentiles"
         lab var rallp  "All Couples, Percentiles"
         lab var rworks "Dual-Earner Couples, Earnings"
         lab var ralls  "All Couples, Earnings"




      **************
      ***FIGURE 2***
      **************


    *recode years to medians

    #delimit ;
    recode y  1968=1969.5 1972=1973.5 1976=1977.5 1980=1981.5
              1984=1985.5 1988=1989.5 1992=1993.5 1996=1997.5
              2000=2001.5 2004=2005;
    #delimit cr


                #delimit ;
            twoway connected   rworkp   rallp rworks ralls  y, c(l)
                                            mlcolor(gs0 gs0 gs0 gs0 gs0)
                                            mfcolor(gs12 gs0 gs0 gs0 gs0)
                                            clcolor(gs0 gs0 gs0 gs0 gs0)
                                            msize(medium medium medium medium medium)
                                            msymbol(s Oh t o)
                                            ysc(r(-.1 .25))  ylabel(-.1(.05).25, labsize(*.9) labgap(.01))
                                            yline(0, lcolor(black))
                                            l1title("Correlation", size(*.9))
                                            scheme(s1color)
                                            graphregion(fcolor(gs16)) plotregion(style(none))
                                            title(" ", size(medlarge) color(gs0)) sub(" ")
                  xlabel(1969.5 `" " 1967-" "1970" "' 1973.5 `" " 1971-" "1974" "'  1977.5 `" " 1975-" "1978" "'
                         1981.5 `" " 1979-" "1982" "' 1985.5 `" " 1983-" "1986" "'  1989.5 `" " 1987-" "1991" "'
                         1993.5 `" " 1991-" "1994" "' 1997.5 `" " 1995-" "1998" "'  2001.5 `" " 1999-" "2002" "'  2005 `" " 2003-" "2005" "', labsize(*.9))
                                            xtitle("Year")
                                            ;
               #delimit cr


               cd "U:\papers and projects\earnings associations\graphs"

         graph export "corr rel vs absolute_1.wmf", replace fontface(garamond)
