#delimit ;
*posslq.do ;
capture log close ;
log using "U:\papers and projects\earnings associations\filecreation\posslq.log", replace ;
set more 1 ;
clear ;
program drop _all ;
set mem 1000M ;


#delimit cr

  use if age >= 21 & age <= 55 using "d:\earn_assoc_archive\marmult_070208.dta" , clear



    *Rename _hhid hhid to match other files
     drop hhid
     rename _hhid hhid





    *DESTRING year

    destring _year, replace
    sort _year hhid lineno



     gen WEIGHT = wgt

     replace WEIGHT = 0 if WEIGHT < 0





    ***Inflation adjustment factors. Here, 2006 gets the
    ***inflation adjustment factor for 2005 because that's
    ***the year for which the earnings pertain. Everything
    ***gets adjusted to 2005 dollars.
    ***source: www.census.gov/hhes/www/income/income06/cpiurs.html


    gen      cpr = (286.7/286.7) if _year == 2006
    replace  cpr = (286.7/277.4) if _year == 2005
    replace  cpr = (286.7/270.1) if _year == 2004
    replace  cpr = (286.7/264.2) if _year == 2003
    replace  cpr = (286.7/260.0) if _year == 2002
    replace  cpr = (286.7/252.9) if _year == 2001
    replace  cpr = (286.7/244.7) if _year == 2000
    replace  cpr = (286.7/239.7) if _year == 1999
    replace  cpr = (286.7/236.4) if _year == 1998
    replace  cpr = (286.7/231.4) if _year == 1997
    replace  cpr = (286.7/225.4) if _year == 1996
    replace  cpr = (286.7/220.1) if _year == 1995
    replace  cpr = (286.7/215.5) if _year == 1994
    replace  cpr = (286.7/210.3) if _year == 1993
    replace  cpr = (286.7/205.1) if _year == 1992
    replace  cpr = (286.7/198.0) if _year == 1991
    replace  cpr = (286.7/188.6) if _year == 1990
    replace  cpr = (286.7/180.8) if _year == 1989
    replace  cpr = (286.7/174.4) if _year == 1988
    replace  cpr = (286.7/168.7) if _year == 1987
    replace  cpr = (286.7/165.7) if _year == 1986
    replace  cpr = (286.7/160.2) if _year == 1985
    replace  cpr = (286.7/153.9) if _year == 1984
    replace  cpr = (286.7/147.6) if _year == 1983
    replace  cpr = (286.7/139.2) if _year == 1982
    replace  cpr = (286.7/127.1) if _year == 1981
    replace  cpr = (286.7/114.4) if _year == 1980
    replace  cpr = (286.7/104.4) if _year == 1979
    replace  cpr = (286.7/100.0) if _year == 1978
    replace  cpr = (286.7/94.0)  if _year == 1977
    replace  cpr = (286.7/88.9)  if _year == 1976
    replace  cpr = (286.7/82.1)  if _year == 1975
    replace  cpr = (286.7/74.7)  if _year == 1974
    replace  cpr = (286.7/70.3)  if _year == 1973
    replace  cpr = (286.7/68.2)  if _year == 1972
    replace  cpr = (286.7/65.3)  if _year == 1971
    replace  cpr = (286.7/62.3)  if _year == 1970
    replace  cpr = (286.7/59.7)  if _year == 1969
    replace  cpr = (286.7/57.4)  if _year == 1968
    replace  cpr = (286.7/55.7)  if _year == 1967
    replace  cpr = (286.7/54.2)  if _year == 1966
    replace  cpr = (286.7/53.3)  if _year == 1965
    replace  cpr = (286.7/52.6)  if _year == 1964
    replace  cpr = (286.7/51.9)  if _year == 1963
    replace  cpr = (286.7/51.4)  if _year == 1962
    replace  cpr = (286.7/50.9)  if _year == 1961
    replace  cpr = (286.7/50.0)  if _year == 1960


    ***Create family size indicator
       bysort hhid _year: gen F = _N

    #delimit ;



    ***KEEP MIS 4-8 to avoid duplicate records

    *keep if mis >= 4 & mis <= 8


    ***Create family size indicator
       bysort hhid _year: gen F = _N

    #delimit ;





    ***WHICH ZEROS ARE VALID ZEROS FOR ANNUAL INCOME.***

     Look at a couple of things. These are all tabs to
     see which zeros are valid zeros and which are zeros
     because they are outside the universe.  Here's what
     the UNICON documentation says about _incwag:


      Note:
            2003-1988B      Universe - those who received any wage and salary
                                       (incs15=1)
                            Construction - incwg1 + (incer1 if ernsrc=1)
                            Although not specifically stated, our tests show that
                            the individual variables are topcoded and then added.
            1988-1968       Universe - adults  (1<=popstat<=2)
            1967-1962       Universe - adults (14<=age)


     Here are the popstat values:

      Code:                                             Recode:
                                03-68   67-63   62      03-62
               Noninterview     0                       0
               Civilian adult   1       1       0       1
               Armed Forces     2       2       1       2
               Child            3               2       3
               Inmates                          3       4




     FINDINGS:

     - The popstat select is not really necessary because there is only 1 observation
       with earnings values where popstat does not equal "Civilian adult" or "Armed
       Forces" within the age range considered here. In 1994 it looks like there is
       1 errant case that has been classified as popstat = "child" whose age is listed
       as 27 and has earnings.

    - incs15 and ernsrc are just flags for whether or not someone had earnings.
      The zeros here aren't missing values, they are legitimate zeros.


     ;

     #delimit cr



******************************************************************
***Roughyl follow Cancian and Reed 1999 in defining the sample ***
******************************************************************



        **CREATE A TOTAL HOUSEHOLD INCOME VARIABLE


          bysort _year hhid: egen ftotinc = sum(_income)


       *(1) Keep civilian adults (drop Armed forces people)

            tab popstat if _year == 1962
            tab popstat if _year >  1962

            keep if (popstat == 0  & _year == 1962) | (popstat == 1 & _year >= 1963)

            tab popstat if _year == 1962
            tab popstat if _year >  1962



       *(3) Drop those who worked part year due to school, retirement, or military service


            #delimit ;


            **Here are the values of the variable:


              <_pyrsn>       What was done most of remaining weeks last year - Unicon recode

                      Code:                                                           Recode:
                                                         04-88B  88-84   83-76   62   04-62
                             NIU                         0       0       0            0
                             Looking for work                                    0*   8*
                             Ill/disabled                1       1       1       1    1
                             Taking care of home/family  2       2       2       3    2
                             Going to school             3       3       3       4    3
                             In Armed Forces                             4            4
                             Retired                     4       5       5            5
                             No work available           5       6                    6
                             Unpaid work                                         2    9
                             Other                       6       7       6       5    7
                             Full year or nonworkers                             6    0
            ;


           #delimit cr


            tab _pyrsn
            tab _pyrsn if age >= 25 & age <= 64

            drop if _pyrsn >= 3 & _pyrsn <= 5



       *(4) Exclude the self-employed


               #delimit ;

               *
               Code:                                                Recode:
                                        03-88B 88-76 75-68 67-63 62 03-62
               NIU                      0      0     0              0
               Private                  1      1     1     1     0  1
               Government                      2     2     2     1  2
               Federal government       2                           2
               State government         3                           2
               Local government         4                           2
               Self-employed                   3     3     3     2  3
               Self-employed, incorp    5                           1
               Self-emp, not incorp     6                           3
               Without pay              7      4     4     4     3  4
               Never worked             8            5              5
               Never worked (FT)               5                    5
               Not emp/exp unemp/ AF                       9        9

               ;


               #delimit cr


            tab _class

            drop if _class == 3  /*using recoded values here*/

            tab _class



       *(5) Cancian and Reed examineh prim-age heads (those 22-55). I examine those
       *    btwn the ages of 21 and 55.


            keep if age >= 21 & age <= 55




   ****Now define POSSLQs***



   sort _year hhid lineno

   *Identify the householder

       gen xhhldr = (_relhd == 1)
       bysort _year hhid: egen hhldr = sum(xhhldr)

       tab hhldr
       tab _year hhldr


      *drop if hhldr > 1



   *Number of adults in household

       gen xnumadlt = (age >= 15)
       bysort _year hhid: egen numadlt = sum(xnumadlt)

       tab numadlt


       keep if numadlt == 2



   *Householder sex

      gen xhhldrsex = sex if _relhd == 1
      bysort _year hhid: egen hhldrsex = sum(xhhldrsex)

      tab hhldrsex






   *Householder sample weight

     *gen xwgt = wgt/100 if _relhd == 1
     *drop wgt
     *bysort _year hhid: egen wgt = sum(xwgt)



    gen nevm = ((marstat == 5 & _year <= 1998) | (marstat == 7 & _year > 1988))


   *Number of male unmarried non-relatives in household




     #delimit ;

     gen     xumnrmal = 1 if age >= 15 & sex== 1 & marstat >= 3 & marstat <= 5 &
                             _relhd >= 5  & _relhd <= 7  ;


     #delimit cr



       bysort _year hhid: egen umnrmal = sum(xumnrmal)





   *Number of female unmarried non-relatives in household



     #delimit ;

     gen     xumnrfem = 1 if age >= 15 & sex== 2 & marstat >= 3 & marstat <= 5 &
                              _relhd >= 5  & _relhd <= 7  ;


     #delimit cr

       bysort _year hhid: egen umnrfem = sum(xumnrfem)




     #delimit ;



   *For POSSLQ, keep only cases where there are two adults in the household, and the
      un-related unmarried adult is of the opposite sex. ;


     *try stipulating that the householder also has to be unmarried. ;

      gen     xumhhldr = (_relhd == 1 & marstat >= 3) ;
      bysort _year hhid: egen umhhldr = sum(xumhhldr) ;


     tab umhhldr ;


      *This variable identifies the households that are POSSLQ households ;

      gen posslq_hh =  (numadlt == 2 & hhldrsex == 1 & umnrfem == 1)  |
                       (numadlt == 2 & hhldrsex == 2 & umnrmal == 1)  ;


      *This variable identifies the adults who are POSSLQ-ing ;

      gen posslq    =  (numadlt == 2 & hhldrsex == 1 & umnrfem == 1 & age >= 15)  |
                       (numadlt == 2 & hhldrsex == 2 & umnrmal == 1 & age >= 15)  ;

     tab umhhldr ;



      #delimit cr




    drop x*





keep if posslq == 1

*keep if _relhd == 1
*tab y [iw=wgt]



  #delimit ;




      preserve ;
       summarize _incwag if _year <= 2004, detail ;
       summarize _incwag if _year == 1970, detail ;
       summarize _incwag if _year == 2003, detail ;
      restore ;




 **************************
 *Educational attainment. *
 **************************



     NOTE: The variables which indicate educational attainment
           switched in 1992. Pre-1992 there are two variables
           that need to be used to construct a highest grade
           of school completed variable: grdhi (hiest grade
           attended) and grdcom (highest grade completed). In
           1992 and after, there is a single variable, grdatn,
           which indicates highest grade completed. Therefore,
           I have to do the coding in two steps. (However,
           1992 has both sets of variables)       -crs 9/6/01 ;

      ***From the UNICON documentation for grdatn from March:


         A user from PPIC who has compared education distributions over
         time between the CPS and the Census, has concluded that people
         with grdhi=13 and grdcom=2 (did not complete grade) should be
         coded as "with some college" when trying to match grdatn codes
         with earlier years. ;


      gen ogrdhi = _grdhi ;


      rename _grdhi grdhi ;

      replace grdhi = ogrdhi - 1 if (grdcom == 2 | grdcom == 7)  & ogrdhi ~= 13 ;


      sort _year ;

      list ogrdhi grdhi grdcom in 1/50 ;


      recode grdhi -1 = 0 ;

      gen edE = grdhi if _year >= 1962 & _year <= 1991 ;

      lab var edE "ed attain, 1968-1991" ;


    *1992-2003 ;

     gen edL = grdatn if _year >= 1992 ;
     lab var edL "ed attain, 1992-2006" ;


    *The documentation on grdhi says that "Tabulations for 1963 indicate all missing values."
     ;

    tab _year if edE == . ;


     gen     edu = edE     if                                   _year >=1962 & _year <=1991 ;

     replace edu = 0  if edL == 00 | edL == 31                & _year >=1992 ;
     replace edu = 4  if edL == 32                            & _year >=1992 ;
     replace edu = 6  if edL == 33                            & _year >=1992 ;
     replace edu = 8  if edL == 34                            & _year >=1992 ;
     replace edu = 9  if edL == 35                            & _year >=1992 ;
     replace edu = 10 if edL == 36                            & _year >=1992 ;
     replace edu = 11 if edL == 37 | edL == 38                & _year >=1992 ;
     replace edu = 12 if edL == 39                            & _year >=1992 ;
     replace edu = 13 if edL == 40 | edL == 41 | edL == 42    & _year >=1992 ; /*14*/
     replace edu = 16 if edL == 43                            & _year >=1992 ;
     replace edu = 18 if edL >= 44 & edL <= 46                & _year >=1992 ;


     tab edL edu ;
     tab edE edu ;


    *Sex ;
    gen male = (sex == 1) ;

    #delimit ;
    rename _year   y ;


    gen edc = edu ;
    recode edc 0/9=1 10/11=2 12=3 13/15= 4 16/18 = 5 ;

     lab def edc   1 "1:lt10"
                   2 "2:10-11"
                   3 "3:12"
                   4 "4:13-15"
                   5 "5:ge16" ;

     lab val edc edc ;

     label var edc "Ed: <10,10-11,12,13-15,16+" ;


     tab edu edc ;




#delimit cr



   ********************************
   * Make husband/wife variables  *
   ********************************

   gen hage = age if male == 1
   gen wage = age if male == 0

   gen hed = edu if male == 1
   gen wed = edu if male == 0

   gen hedc= edc if male == 1
   gen wedc= edc if male == 0


   gen hagrdhi= agrdhi if male == 1
   gen wagrdhi= agrdhi if male == 0

   gen hagrdatn= agrdatn if male == 1
   gen wagrdatn= agrdatn if male == 0


   **The weight will be the sum of the H&W's person weights
   gen hWEIGHT = WEIGHT if male == 1
   gen wWEIGHT = WEIGHT if male == 0

   gen hincwag = _incwag if male == 1
   gen wincwag = _incwag if male == 0

   gen hincse = _incse if male == 1
   gen wincse = _incse if male == 0

   gen hincfrm = _incfrm if male == 1
   gen wincfrm = _incfrm if male == 0

   gen hinctot = _income if male == 1
   gen winctot = _income if male == 0

   gen hfaminc = _faminc if male == 1
   gen wfaminc = _faminc if male == 0

   gen hwkslyr = _wkslyr if male == 1
   gen wwkslyr = _wkslyr if male == 0


   quietly compress

   gen hhcount = 1


      preserve
       summarize hincwag if y <= 2004, detail
       summarize hincwag if y == 1970, detail
       summarize hincwag if y == 2003, detail
      restore



   *************************************************
   * CREATE COUPLE-LEVEL FILE                      *
   *************************************************

   display _N

   gen oy = y

   replace y = oy - 1900

   tab y

   *Make sure the data look right
   sort y hhid

   list y hhid hage wage hed wed hincwag wincwag male WEIGHT in 1/15


    *First collapse: couple-level file

   #delimit ;
   collapse (mean) hage wage hed wed hedc wedc hincwag wincwag hinctot winctot hwkslyr wwkslyr
                   wagrdatn hagrdatn wagrdhi hagrdhi hfaminc wfaminc F wincse hincse wincfrm hincfrm ?WEIGHT
                   cpr ftotinc /*maxinc maxwag*/                   (sum) hhcount, by(hhid y) ;
   #delimit cr



   *Make sure the data look right
   sort y hhid

   list y hhid hage wage hed wed hincwag wincwag in 1/15 , clean


      preserve
       summarize hincwag if y <= 104, detail
       summarize hincwag if y == 70, detail
       summarize hincwag if y == 103, detail
      restore



   *drop those who don't have a spouse record, but first
   *create a flag

   gen nospouse = (hage == . | wage == .)

   tab nospouse

   display _N

   drop if nospouse == 1

   display _N

   *Drop those with more than 2 married people in household. We don't
   *know which people form the marital unit

   gen drop10 = (hhcount > 2)

   tab drop10


   drop if drop10 == 1

   display _N

    gen drop11 = hed == . | wed == .
    bysort y: tab drop11
  * drop if drop11 == 1

   display _N


   drop drop*




  ****Following Cancian and Reed, the WEIGHT is the sum of the person weights

      gen WEIGHT = hWEIGHT + wWEIGHT
      drop ?WEIGHT



   ***************************************************
   * CONTINUE WITH CANCIAN AND REED SAMPLE SELECTION *
   ***************************************************



       *(4) Drop couples where either income or wages are missing


        #delimit ;

        *    <_incwag>      Income from wage and salary - Unicon recode

        Code:

                      04-96     95-88B   88-85   84-82   81-76   75-68   67-62

        None or NIU   000000    000000   00000   00000   00000   0       0 or .

        Top value     varies    199998   99999   75000   50000   +50000  99999

        Recode NIU                                               99999=.



        Interestingly, cancian and reed seem to assume that when _income is missing
        it equals 0, see their SAS code:

          if income ne . then totinc=income
            else totinc=0

        I am not implementing this decision here, but if I can't get my sample to
        match theirs, I should try this.

        ;

        #delimit cr


        tab hincwag if hincwag == .
        tab wincwag if wincwag == .
        tab hinctot if hinctot == .
        tab hfaminc if hfaminc == .

        bysort y: tab hincwag if hincwag == 99999
        bysort y: tab wincwag if wincwag == 99999
        bysort y: tab hinctot if hinctot == 99999
        bysort y: tab hfaminc if hfaminc == 99999


           *Only drop in years in which 99999s indicate missing values rather than top codes. (Nothing gets dropped)
            drop if (hincwag == 99999 | hincwag == . | wincwag == 99999 | wincwag == .) & y >= 1968 & y <= 1975
            drop if (                   hincwag == . |                    wincwag == .) & y >= 1962 & y <= 1967
            drop if (hinctot == 99999 | hinctot == . | winctot == 99999 | winctot == .) & y >= 1968 & y <= 1975
            drop if (hfaminc == 99999 | hfaminc == . | wfaminc == 99999 | wfaminc == .) & y >= 1968 & y <= 1975





      *CHECK:::Is family income consistent across couples?

             gen flag = (hfaminc ~= wfaminc)
             tab flag

             list hfaminc wfaminc hhid y if flag == 1


             *USE HUSBAND'S REPORT

             drop wfaminc
             rename hfaminc faminc




       **(5) CONSTRUCT CANCIAN AND REED earnings measures and
       **    delete those with missing earnings (following C&R program).***


             gen wearn     = wincwag /*+ wincfrm + wincse*/
             gen hearn     = hincwag /*+ hincfrm + hincse*/
             gen wearn_all = wincwag   + wincfrm + wincse
             gen hearn_all = hincwag   + hincfrm + hincse


             gen wearn_miss = (wearn == .)
             gen hearn_miss = (hearn == .)

             tab wearn_miss hearn_miss, cell

             drop if wearn_miss == 1 | hearn_miss == 1



 quietly compress
 save "U:\papers and projects\earnings associations\dta\posslq.dta", replace


 *What's the sample size?

  tab y

 log close

